
function Optim(eco::Projection,params::AiyagariParametersEGM)
############
    
    

amin   = minimum(eco.aep./eco.Sp)
ns     = eco.ns
Nbin      = eco.Nbin
χ      = params.χ
w      = eco.w
R      = eco.R
states = eco.states
ytype  = eco.ytype
ϕ      = params.ϕ
β      = params.β
γ      = params.γ
α      = params.α
δ      = params.δ
Ucp    = vec(eco.Ucp) #not per capita
Sp     = vec(eco.Sp)
Ap     = Ucp./Sp
A      = eco.A
tauc   = A/sum(eco.aep)-1
#Ly    = vec(transpose(eco.lb*ones(1,eco.L)))
Ly     = eco.lb[ytype].*states[ytype]
Lv     = eco.lb[ytype]
TT     = eco.Agg.TT    
PI      = eco.Matab     
    

Xp     = vec(eco.cp./eco.Sp) - (1/(χ*(1+1/ϕ)))*Lv.^(1+1/ϕ) # Argument utility function
θ      = 0# eco.θ
#Xp[findall(x->x==2,2 .*isnan.(Xp))] .=1.0
uSecond(X) = (-γ).*(X.^(-γ-1))

#=
    if γ==1
    Uvv(X) = log.(X)
else
    Uvv(X) =  (X.^(1-γ)-1)./(1-γ)
end
 =#   


Uccp = (-γ).*(Xp.^(-γ-1))
UcpV = Xp.^-γ # per capita

    
   
#######################
# Constructing H1 et H2 
#######################

Sp[findall(x->x<=10^-20,Sp)] .=10^-10
Diagp = diagm(Sp)
iDiagp = diagm(1.0 ./Sp)

PIt = transpose(PI)    

#PIupc = iDiagp*eco.PIup*Diagp   
    
PIS = Diagp*transpose(PI)*iDiagp # per capita, whereas PIup is not)

#Id = Matrix{Float64}(I, ns*L, ns*L)
Id = sparse(I,Nbin,Nbin)
Bp  = diagm(eco.xsip .*Uccp)*(R*PI - Id)

#PIh = Diagp*PIa*iDiagp 
#PIh = PIS    


 
    
P = sparse(I,eco.Nbin,eco.Nbin);
for i=eco.indcc
    P[i,i]=0
end
Pc = Id - P     
    
#P  = diagm(vec([ones(1,ns)-vectc;ones(L-1,ns)]))
#Pc =  diagm(ones(ns*L)-vec([ones(1,ns)-vectc;ones(L-1,ns)]))

#Ly = vec(transpose((states.*eco.lb)*ones(1,eco.L)))

Ltot = sum(Sp.*Ly) #it is also  L=(χ*w)^ϕ    
K = Ltot*(( (1/β - 1 + δ))/α ) ^(-1/(1-α)) 
FL = (1-α)*(K/Ltot)^α
FK = 1/β - 1 #α*(K/Ltot)^(α - 1.0)- δ


M  = Id - β*R*PIS +β*((R-1/β)/(Ltot*(1+ϕ*(w-FL)/w)))*Sp*transpose(collect(Ly))
J  = -inv(Pc+P*M*Bp)*P*M
NN  = Id - Bp*inv(Pc+P*M*Bp)*P*M

abc = vec(eco.abp ./ eco.Sp)# beginning-of-period per capita
abc[findall(x->x>10^30,abc)] .=0    # if size is very small
        
Q  = (1/(Ltot*(1+ϕ*(w-FL)/w)))*transpose(Ly)*NN        

H1t= ones(1,Nbin)*(diagm(abc)*NN + diagm(UcpV.*eco.xsip)*PI*J)-A*Q     
H2t = ones(1,Nbin)*NN - Q        

H1 = H1t*diagm(Sp.*eco.xsip.*UcpV)
H2 = H2t*diagm(Sp.*eco.xsip.*UcpV)

    
#######################
# finding w
#######################

#k1 = sum(H1)
#k11 = sum(H1.*H1)
#k2 = sum(H2)
#k22 = sum(H2.*H2)
#k12 = sum(H2.*H1)
#KK = [k11 k12;k12 k22]
#La = -inv(KK)*[k1;k2]
#ω = ones(1,ns*L)+La[1]*(H1)+La[2]*(H2)

#    while 0>1#sum(ω.<0)>0
#    Pω[findall(x->x<0,ω)] .=0
#    k1 = sum(Pω.*H1)
#    k11 = sum(Pω.*H1.*H1)
#    k2 = sum(Pω.*H2)
#    k22 = sum(Pω.*H2.*H2)
#    k12 = sum(Pω.*H2.*H1)
#    KK = [k11 k12;k12 k22]
#    La = -inv(KK)*[k1;k2]
#    ω = Pω.*(ones(1,ns*L)+La[1]*H1+La[2]*H2)     
#end
    
    
Spv = transpose(vec(eco.Sp))    
k1 = sum(H1)
k11 = sum(H1.*H1./Spv)
k2 = sum(H2)
k22 = sum(H2.*H2./Spv)
k12 = sum(H2.*H1./Spv)
KK = [k11 k12;k12 k22]
La = -inv(KK)*[k1;k2]
    

    
ω = ones(1,Nbin)+La[1]*(H1./Spv)+La[2]*(H2./Spv)
#ω[findall(x->x<0,ω)] .=0.01
#ω = ω .- minimum(ω)
    
# considering positive coefficients
    Pω = ones(1,Nbin)

while 0>1#sum(ω.<0)>0
    Pω[findall(x->x<0,ω)] .=0
    k1 = sum(Pω.*H1)
    k11 = sum(Pω.*H1.*H1./Spv)
    k2 = sum(Pω.*H2)
    k22 = sum(Pω.*H2.*H2./Spv)
    k12 = sum(Pω.*H2.*H1./Spv)
    KK = [k11 k12;k12 k22]
    La = -inv(KK)*[k1;k2]
    ω = Pω.*(ones(1,ns*L)+La[1]*(H1./Spv)+La[2]*(H2./Spv))     
end


#ωt = reshape(ω,L,ns)
#plot(ωt,st=:surface,camera=(-50,20))
#savefig("3D.png")
#plot(transpose(sum(ωt,dims=1)/L))
#plot(sum(ωt,dims=2)/ns)
#savefig("fig.png")



###############
#  Check
###############
Uv  = diagm(Sp.*eco.xsip.*UcpV)*vec(ω)
Uvc  = eco.xsip.*UcpV.*vec(ω)
Sλ  = J*Uv
Sψ  = NN*Uv
μ   = Q*Uv

    

ψh = μ*ones(Nbin,1)- Sψ./Sp  
λ = Sλ./Sp    
λt  = iDiagp*PI*Diagp*λ  
    
CC = zeros(Float64,6)
CC[1] = maximum(ψh - (μ*ones(Nbin,1)- Uvc  + diagm(eco.xsip .*Uccp)*(λ - R*λt)))
CC[2] = maximum(P*ψh - β*R*P*PIt*ψh)
CC[3] = maximum(Pc*λ)
CC[4] = maximum(sum(Ly.*Sp.*ψh) - μ*Ltot*ϕ*(FL-w)/w)
CC[5] = sum( ψh.*vec(eco.abp)) - sum(Sp.*λt.*eco.xsip.*UcpV)
CC[6] = sum(Sp.*ψh) 

    
    
    
    


Pl = Plan(vec(λ),vec(λt),vec(ψh),vec(ω),vec(Uvc),vec(CC),μ)
return Pl 
end
