clear
warning('off','all');

load todynaremone.mat

K     = eco.A-eco.B;
Ltot  = (chi*eco.w)^phi;
Y     = K^alpha*Ltot^(1-alpha);
 
rho_u = 0.95;

wtemp = (1-alpha)*((1/beta-1+delta)/alpha)^(alpha/(alpha-1));
chi = 3^(-1/phi)/wtemp


fid = fopen('code_dynare_hatRA.mod', 'w') ;
formatSpec = '%16.8f';



str = ['var\n'] ; fprintf(fid, str);

str = ['u r w K TFP L C GDP \n'] ; fprintf(fid, str);
str = ['ut Kt Ct wt rt Zt GDPt Uc L mu psi lambda Ucc A B rtilde wtilde tauk taul Bt tk tl mut zero\n'] ; fprintf(fid, str);  

str = ['; \n\n'] ; fprintf(fid, str);

str = ['varexo eps; \n\n'] ; fprintf(fid, str);


str = ['parameters\n'] ; fprintf(fid, str);

str = ['beta alpha phi abar delta gamma chi rho_u G ;\n\n'] ; fprintf(fid, str);


str = ['alpha','   = ',num2str(alpha),';\n']; fprintf(fid, str); 
str = ['beta','    = ',num2str(beta),';\n']; fprintf(fid, str); 
str = ['phi','     = ',num2str(phi),';\n']; fprintf(fid, str); 
str = ['abar','   = ',num2str(min(eco.aep)),';\n']; fprintf(fid, str); 
str = ['delta','   = ',num2str(delta),';\n']; fprintf(fid, str);
str = ['gamma','   = ',num2str(gamma),';\n']; fprintf(fid, str);
str = ['rho_u','   = ',num2str(rho_u),';\n']; fprintf(fid, str); %HERE
str = ['G','       = ',num2str(G,formatSpec),';\n']; fprintf(fid, str);
str = ['chi','     = ',num2str(chi),';\n']; fprintf(fid, str);


%%
equa = 1;

str = ['%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%'] ; fprintf(fid, str); 
str = ['\n\n'] ; fprintf(fid, str);    

str = ['model;\n\n']; fprintf(fid, str);
         
%%%%%%%% Budget constraint  
 str = ['C + A =w*L+(1+r)*A(-1);']; fprintf(fid, str);str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
 str = ['L  = (chi*w)^phi;']; fprintf(fid, str);str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
 str = ['Uc  = (C- (1/chi)*L^(1+1/phi)/(1+1/phi))^-gamma;']; fprintf(fid, str);str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
 str = ['Ucc  = -gamma*(C- (1/chi)*L^(1+1/phi)/(1+1/phi))^(-gamma-1);']; fprintf(fid, str);str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
 
 str = ['Uc  = beta*(1+r(+1))*Uc(+1);']; fprintf(fid, str);str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
 %str = ['w  = (1-alpha)*TFP*K^alpha*L^-alpha;']; fprintf(fid, str);str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
 %str = ['r  = alpha*TFP*K^(alpha-1)*L^(1-alpha)- delta;']; fprintf(fid, str);str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
 
str = ['TFP = 1 - u;'] ; fprintf(fid, str);  str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
str = ['u = rho_u*u(-1) + eps;'] ; fprintf(fid, str);    str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
str = ['GDP = TFP*K(-1)^alpha*L^(1-alpha);'] ; fprintf(fid, str);      str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;

str = ['psi = beta*(1+r(+1))*psi(+1);'] ; fprintf(fid, str);      str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
str = ['psi = mu*phi*((1-alpha)*TFP*K(-1)^alpha*L^-alpha -w)/w;'] ; fprintf(fid, str);      str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
str = ['psi*A(-1) = lambda(-1)*Uc;'] ; fprintf(fid, str);      str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
str = ['mu = beta*mu(+1)*(1+alpha*TFP*K^(alpha-1)*L(+1)^(1-alpha)-delta ) ;'] ; fprintf(fid, str);      str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
str = ['psi = mu - Uc +(lambda-lambda(-1)*(1+r))*Ucc;'] ; fprintf(fid, str);      str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;

str = ['G +B(-1) +r*A(-1) +w*L = B + GDP - delta*K(-1);'] ; fprintf(fid, str);      str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
str = ['A = K+B;'] ; fprintf(fid, str);      str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;


%%%%%%%% variables in percent deviations 

str = ['ut = 100*u;'] ; fprintf(fid, str);  str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
str = ['Kt = 100*(K/steady_state(K)-1);'] ; fprintf(fid, str);  str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
str = ['Ct = 100*(C/steady_state(C)-1);'] ; fprintf(fid, str);  str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
str = ['wt = 100*(w/steady_state(w)-1);'] ; fprintf(fid, str);  str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
str = ['rt = 100*(r - steady_state(r));'] ; fprintf(fid, str); str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
str = ['Zt = -ut;'] ; fprintf(fid, str);  str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
%str = ['PIt = 100*(PI-1);'] ; fprintf(fid, str);  str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
str = ['GDPt = 100*(GDP/steady_state(GDP)-1);'] ; fprintf(fid, str);  str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;


str = ['Bt = 100*(-B/steady_state(B)-1);'] ; fprintf(fid, str);  str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
str = ['tk = 100*(tauk - steady_state(tauk));'] ; fprintf(fid, str);  str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
str = ['tl = 100*(taul - steady_state(taul) );'] ; fprintf(fid, str);  str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
str = ['mut = 100*(mu/steady_state(mu)-1);'] ; fprintf(fid, str);  str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;


str = ['rtilde = alpha*TFP*K(-1)^(alpha-1)*L^(1-alpha)-delta  ;'] ; fprintf(fid, str);      str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
str = ['wtilde = (1-alpha)*TFP*K(-1)^alpha*L^-alpha;'] ; fprintf(fid, str);      str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
str = ['tauk = 1-r/rtilde;'] ; fprintf(fid, str);  str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
str = ['taul = 1-w/wtilde;'] ; fprintf(fid, str);  str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
str = ['zero = 0.00001;'] ; fprintf(fid, str);  str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;


str = ['\n'] ;         fprintf(fid, str);
str = ['end;\n\n'] ; fprintf(fid, str);    
     
str = ['%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%'] ; fprintf(fid, str);    
str = ['\n\n'] ; fprintf(fid, str);    
     
%%    
%str = ['steady_state_model;\n\n'] ; fprintf(fid, str);   
str = ['initval;\n\n'] ; fprintf(fid, str);   

 
str = ['r = ', num2str(1/beta-1,formatSpec),';\n'] ; fprintf(fid, str);
str = ['w = ', num2str(eco.w,formatSpec),';\n'] ; fprintf(fid, str);
str = ['K = ', num2str(K,formatSpec),';\n'] ; fprintf(fid, str);
str = ['L = (chi*w)^phi;\n'] ; fprintf(fid, str); 
str = ['TFP = ', num2str(1),';\n'] ; fprintf(fid, str);
str = ['u = ', num2str(0),';\n'] ; fprintf(fid, str);
str = ['C = ', num2str(Ctot,formatSpec),';\n'] ; fprintf(fid, str);
str = ['GDP = ', num2str(Y,formatSpec),';\n'] ; fprintf(fid, str);
str = ['Uc  = (C- (1/chi)*L^(1+1/phi)/(1+1/phi))^-gamma;\n']; fprintf(fid, str);
str = ['Ucc  = -gamma*(C- (1/chi)*L^(1+1/phi)/(1+1/phi))^(-gamma-1);\n']; fprintf(fid, str);

str = ['B = -10;\n'] ; fprintf(fid, str);
str = ['A = K;\n'] ; fprintf(fid, str);
str = ['mu = Uc;\n'] ; fprintf(fid, str);
str = ['lambda = 0;\n'] ; fprintf(fid, str);
str = ['psi = 0;\n'] ; fprintf(fid, str);

str = ['rtilde = alpha*TFP*K^(alpha-1)*L^(1-alpha)-delta  ;'] ; fprintf(fid, str);     
str = ['wtilde = (1-alpha)*TFP*K^alpha*L^-alpha;'] ; fprintf(fid, str);   
str = ['tauk = 1-r/rtilde;'] ; fprintf(fid, str); 
str = ['taul = 1-w/wtilde;'] ; fprintf(fid, str); 



str = ['ut = 0;\n'] ; fprintf(fid, str);  
str = ['Kt = 0;\n'] ; fprintf(fid, str);  
str = ['Ct  = 0;\n'] ; fprintf(fid, str);  
str = ['wt = 0;\n'] ; fprintf(fid, str);  
str = ['rt = 0;\n'] ; fprintf(fid, str); 
str = ['Zt = 0;\n'] ; fprintf(fid, str); 
str = ['GDPt = 0;\n'] ; fprintf(fid, str); 


str = ['Bt = 0;'] ; fprintf(fid, str);  
str = ['tk = 0;'] ; fprintf(fid, str);  
str = ['tl = 0;'] ; fprintf(fid, str);  
str = ['mut = 0;'] ; fprintf(fid, str); 
str = ['zero = 0;'] ; fprintf(fid, str);  


str = ['end;\n\n'] ; fprintf(fid, str);    

%%
str = ['resid;\n\n'] ; fprintf(fid, str);    
%str = ['options_.solve_tolf=10^-6;\n\n'] ; fprintf(fid, str);   
%str = ['steady(maxit = 100,solve_algo=3);\n\n'] ; fprintf(fid, str);  

str = ['steady;\n\n'] ; fprintf(fid, str);


%str = ['steady(nocheck);\n\n'] ; fprintf(fid, str); 
%str = ['check;\n\n'] ; fprintf(fid, str);    

str = ['shocks;\n var eps = 0.0001;\nend;\n'] ; fprintf(fid, str);         
str = ['stoch_simul (order=1,irf=200, periods=10000) ut Kt Ct Bt wt rt tk tl mut GDPt Zt u C K GDP L tauk taul B zero;'] ; fprintf(fid, str);         


%str = ['stoch_simul (order=1,irf=200) ut Kt Ct Bt wt rt tk tl Tt mut GDPt;'] ; fprintf(fid, str);      
dynare code_dynare_hatRA noclearall

save tofigaggRA ut_eps GDPt_eps Ct_eps wt_eps rt_eps Kt_eps tk_eps tl_eps mut_eps Bt_eps
save totableRA oo_

    
    
    