
clear
clc
warning('off','all');
%load todynare

load todynare_reiter 

%

Ntot = na*ns;
Ny = ns;
thres       = 0;% threshold to consider 0 (not to have too many equations)

phil        = phi; % phi of labor supply, not to get confused 
xsil        = xsi; % xsi of labor supply, not to get confused 
sigma       = gamma; % change of notaiton here, concavity of utility function

rho_u       = 0.95;

sigma_u     = 0.00312;

fid         = fopen('dynare_reiter.mod', 'w') ;
formatSpec  = '%16.12f';


str         = ['var\n'] ; fprintf(fid, str);
str         = ['r w Z K GDP Ltot u I C LGDP LC LI LL Lw A B tauk taul FK FL TT Ctot LK LB\n'] ; fprintf(fid, str);
%str         = ['LGDP LC LI LL Lw dY dK dL dC du Ineq df dU I\n'] ; fprintf(fid, str);


for i = 1:Ntot
    str     = ['ap',num2str(i),' '] ; fprintf(fid,str);        
    str     = ['c',num2str(i),' '] ; fprintf(fid, str);  
    str     = ['S',num2str(i),' '] ; fprintf(fid, str); 
    str     = ['ww',num2str(i),' '] ; fprintf(fid, str); 
    if mod(i,10)==0; %multiple de 10
        str = ['\n'] ;         fprintf(fid, str);
    end;    
end;
for i = 1:Ny
    str     = ['l',num2str(i),' '] ; fprintf(fid, str);      
    if mod(i,10)==0; %multiple de 10
        str = ['\n'] ;         fprintf(fid, str);
    end;    
end;
str         = ['; \n\n'] ; fprintf(fid, str);

str         = ['varexo eps; \n\n'] ; fprintf(fid, str);
str         = ['parameters\n'] ; fprintf(fid, str);
str         = ['beta alpha abar delta sigma rho_u xsil phil G\n'] ; fprintf(fid, str);
str = ['; \n\n'] ; fprintf(fid, str);

l0          = 0;
abar        = abar;
 
str         = ['alpha','   = ',num2str(alpha),';\n']; fprintf(fid, str); 
str         = ['beta ','   = ',num2str(beta),';\n']; fprintf(fid, str); 
str         = ['abar ','   = ',num2str(abar),';\n']; fprintf(fid, str); 
str         = ['sigma','   = ',num2str(sigma),';\n']; fprintf(fid, str); 
str         = ['rho_u','   = ',num2str(rho_u),';\n']; fprintf(fid, str); %HERE
str         = ['delta','   = ',num2str(delta),';\n']; fprintf(fid, str);
str         = ['l    ','   = ',num2str(l0),';\n']; fprintf(fid, str);
str         = ['phil ','   = ',num2str(phil),';\n']; fprintf(fid, str);
str         = ['xsil ','   = ',num2str(xsil),';\n']; fprintf(fid, str);
str         = ['G ','   = ',num2str(G),';\n']; fprintf(fid, str);



str = ['\n\n'] ; fprintf(fid, str);


yv = ytype; %vector of productivity type from 1 to 2*ns*na (for budget constraint)
yvv = [1:1:ns]; %vector of productivity type from 1 to ns 
Th = 10^-8;
indc    = find(apol <= Th); %credit constraind agents
indnc = find(apol >Th); 

%%  

str     = ['%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%'] ; fprintf(fid, str); 
str     = ['\n\n'] ; fprintf(fid, str);    

str     = ['model;\n\n']; fprintf(fid, str);
equa    = 1;
%%%%%%%%%%%%%%%%% LABOR SUPPLY %%%%%%%%%%%%%
for i = 1:Ny
    str = ['l',num2str(i),' =  (',num2str(states(i)*xsil,formatSpec),'*w)^',num2str(phil),';']; fprintf(fid, str);
    str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1; 
end;

%%%%%%%%%%%%%%%%% BUDGET CONSTRAINTS %%%%%%%%%%%%%

for i = 1:Ntot
    str = ['c',num2str(i),'+ap',num2str(i), ' = TT +w*',num2str(states(yv(i)),formatSpec),'*l',num2str(yv(i)),'+ (1+r)*',num2str(aGrid(i)),';']; fprintf(fid, str);str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;     
end;
str = ['\n\n']; fprintf(fid, str);


%%%%%%%%%%%%%%%%  WEALTH TRANSITION  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
for i = 1:Ntot 
     str = ['ap',num2str(i),' =  ww',num2str(i),'*',num2str(aGrid(Vind(i))),'+ (1 -ww',num2str(i),')*',num2str(aGrid(Vind(i)+1)),';']; fprintf(fid, str);
     str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;  
     
end;    
str = ['\n\n']; fprintf(fid, str);

%%%%%%%%%% EULER EQUATIONS %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
str     = ['%%%%%%%% equation ',num2str(equa),': Euler\n\n']; fprintf(fid, str);
 
for i = 1:length(indc)    
     str = ['ap',num2str(indc(i)),' = ',num2str(abar) ,';']; fprintf(fid, str); str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1; 
end;


for k = 1:length(indnc)
    i = indnc(k);   
    yi = ytype(i);% current productivity status
    threse = 0;   

   
   
          str = ['(c',num2str(i),'-( l',num2str(yv(i)),'^(1+1/phil))/(xsil*(1+1/phil)))^-sigma  = beta*(1+r(+1))*('];fprintf(fid, str);
          kk=1; % next period employment status (u to u) 
          for j = 1:ns % next period productivity status
                  if (Trans(j,yi)>threse) % Does agent i reach agent j ? effective transition toward the bin j
                     str = ['+',num2str(Trans(j,yi),formatSpec),'*(ww',num2str(i),'*c',num2str(Vind(i)+(j-1)*na),'(+1)+(1-ww',num2str(i),')*c',num2str(Vind(i)+1+(j-1)*na),'(+1)']; fprintf(fid, str);                                           
                     str = ['-(l',num2str(yvv(j)),'(+1)^(1+1/phil)) /(xsil*(1+1/phil))  )^-sigma']; fprintf(fid, str); % stay unemployed
                  end;
          end;
                    
            str = [')+',num2str(resE(i),formatSpec),';']; fprintf(fid, str);
            str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;     
 
end        
 
%%%%%%%%%%%%%%%%%%%%%%%%%  SHARES  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 str    = [' %%%%%%%% equation ',num2str(equa),': Shares \n\n']; fprintf(fid, str);

for i = 1:na
    for j=1:ns   
              
        pass=0;
        ind =   i + (j-1)*na ;
        str    = ['S',num2str(ind),' = ']; fprintf(fid, str); 
        
        for ip = 1:na
            for jp=1:ns               
               indp =   ip + (jp-1)*na;
               if (Vind(indp)==i)&(Trans(j,jp)>0) %goes from indp to ip (i+1 appears later)
                        str    = ['+S',num2str(indp),'(-1)*',num2str(Trans(j,jp),formatSpec),'*(',num2str(aGrid(Vind(indp)+1),formatSpec) ,'-ap',num2str(indp),'(-1))/',num2str(aGrid(Vind(indp)+1)-aGrid(Vind(indp)),formatSpec)]; fprintf(fid, str);pass=1;
               end
               if (Vind(indp)==i-1)&(Trans(j,jp)>0) %goes from indp to ip (i+1 appears later)
                        str    = ['+S',num2str(indp),'(-1)*',num2str(Trans(j,jp),formatSpec),'*(ap',num2str(indp),'(-1)-',num2str(aGrid(Vind(indp)),formatSpec) ,')/',num2str(aGrid(Vind(indp)+1)-aGrid(Vind(indp)),formatSpec)]; fprintf(fid, str);pass=1;
               end
            end
        end
         if pass==0
          str    = [num2str(D_ss(ind),formatSpec)]; fprintf(fid, str); 
        end
       str    = [';']; fprintf(fid, str); str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1; 
    end
end
       



%%%%%%%%%%%%%%%%%%%%%  AGGREGATIONS  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
str = [' %%%%%%%% equation ',num2str(equa),': Aggretations \n\n']; fprintf(fid, str);

%%%%% shock on K
%str = ['K = steady_state(K)+u;'];  fprintf(fid, str);str = [' %% equation ', num2str(equa),'\n\n']; fprintf(fid, str); equa = equa+1;  
  

%current period capital stock
% str = ['K = ']; fprintf(fid, str);
% for i = 1:Ntot
%      str    = ['+S',num2str(i),'*',num2str(aGrid(i),formatSpec)]; fprintf(fid, str);
%       if mod(i,10)==0; %multiple de 10
%          str = ['\n'] ;         fprintf(fid, str);
%      end;  
% end;
% str = [';'] ;         fprintf(fid, str);str = [' %% equation ', num2str(equa),'\n\n']; fprintf(fid, str); equa = equa+1;  

%%%%%%%% Saving agents
str = ['A = ']; fprintf(fid, str);
for i = 1:Ntot
     str    = ['+S',num2str(i),'(-1)*ap',num2str(i),'(-1)']; fprintf(fid, str);
      if mod(i,10)==0; %multiple de 10
         str = ['\n'] ;         fprintf(fid, str);
     end;  
end;
str = [';'] ;         fprintf(fid, str);str = [' %% equation ', num2str(equa),'\n\n']; fprintf(fid, str); equa = equa+1;  




% str = ['L = ']; fprintf(fid, str);
% for i = Ntot/2+1:Ntot
%      str    = ['+S',num2str(i),'*',num2str(states(yv(i)),formatSpec),'*l',num2str(yv(i))]; fprintf(fid, str);
%       if mod(i,10)==0; %multiple de 10
%          str = ['\n'] ;         fprintf(fid, str);
%      end;  
% end;
%str = [';'] ;         fprintf(fid, str);str = [' %% equation ', num2str(equa),'\n\n']; fprintf(fid, str); equa = equa+1;
% str = ['U = ']; fprintf(fid, str);
% for i = 1:Ntot/2
%      str    = ['+S',num2str(i)]; fprintf(fid, str);
%       if mod(i,10)==0; %multiple de 10
%          str = ['\n'] ;         fprintf(fid, str);
%      end;  
% end;
% str = [';'] ;         fprintf(fid, str);str = [' %% equation ', num2str(equa),'\n\n']; fprintf(fid, str); equa = equa+1;



str = ['I =  K(+1) - ( 1 - delta)*K;']; fprintf(fid, str); str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;   
str = ['C =  GDP - G - I;']; fprintf(fid, str); str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;   

%%%%%%%% Budget contraint of the state 
%str = ['B + GDP -delta*K(-1) +',num2str(1+tauc) ,'*Ctot= G + TT*(1+theta) + (1+r)*B(-1) +r*K(-1) + w*Ltot;\n'] ; fprintf(fid, str);    
str = ['B + GDP -delta*K(-1) = G + TT + B(-1) +r*A(-1) + w*Ltot;'] ; fprintf(fid, str);   str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
%str = ['G + Ctot + K = GDP - delta*K(-1) + K(-1);\n'] ; fprintf(fid, str);   
%%%%%%%% Financial market eq
str = ['A = B + K;'] ; fprintf(fid, str);str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
%%%%%%%% Production side
str = ['FL = (1 - alpha)*Z*(K(-1)/Ltot)^alpha;'] ; fprintf(fid, str);   str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1; 
str = ['FK = alpha*Z*(K(-1)/Ltot)^(alpha-1)-delta;'] ; fprintf(fid, str);   str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1; 
str = ['u = rho_u*u(-1) + eps;'] ; fprintf(fid, str);    str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
str = ['Z = 1 - u;'] ; fprintf(fid, str);  str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
str = ['Ltot = (xsil*w)^phil;'] ; fprintf(fid, str);  str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
str = ['GDP = Z*K(-1)^alpha*Ltot^(1-alpha);'] ; fprintf(fid, str);      str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
  
%%%%%%%% total consumption
str = ['\n'] ;         fprintf(fid, str);
str = ['Ctot ='] ; fprintf(fid, str);    
for h = 1:Ntot
        str = ['+S',num2str(h),'*c',num2str(h)] ; fprintf(fid, str);  
         if mod(h,5)==0; %multiple de 10
        str = ['\n'] ;         fprintf(fid, str);
    end; 
end;
str = [';']; fprintf(fid, str);str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;

%%%%%%%% Taxes
 str = ['tauk = 1-r/FK;'] ; fprintf(fid, str);  str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
 str = ['taul = 1-w/FL;'] ; fprintf(fid, str);  str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
 
str = ['LGDP = log(GDP);']; fprintf(fid, str); str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;   
str = ['LC   = log(C);']; fprintf(fid, str); str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;   
str = ['LI   = log(I);']; fprintf(fid, str); str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;   
str = ['LL   = log(Ltot);']; fprintf(fid, str); str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;   
str = ['Lw   = log(w);']; fprintf(fid, str); str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;   
str = ['LK   = log(K);']; fprintf(fid, str); str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;   
str = ['LB   = log(B);']; fprintf(fid, str); str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;   

%note when u is 1 it is already in percent
% u Z PHI LGDP LI LC LL Lw K L tau f U

str = ['tauk = steady_state(tauk);'] ; fprintf(fid, str);  str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
%str = ['taul = steady_state(taul)+0.1*(B-steady_state(B));'] ; fprintf(fid, str);  str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
str = ['B = steady_state(B);'] ; fprintf(fid, str);  str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
str = ['TT = steady_state(TT);'] ; fprintf(fid, str);  str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;
 



str = ['end;\n\n'] ; fprintf(fid, str);  



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
str = ['%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%'] ; fprintf(fid, str);   
str = ['\n\n'] ; fprintf(fid, str);    






%str = ['initval;\n\n'] ; fprintf(fid, str);  

str = ['steady_state_model;\n\n'] ; fprintf(fid, str);           
for i = 1:Ntot
    str = ['ap',num2str(i),' = ',num2str(apol(i),formatSpec),';\n'] ; fprintf(fid, str);       
    str = ['c',num2str(i), ' = ',num2str(Cpol(i),formatSpec),';\n'] ; fprintf(fid, str); 
    str = ['S',num2str(i), ' = ',num2str(D_ss(i),formatSpec),';\n'] ; fprintf(fid, str);    
     str = ['ww',num2str(i), ' = ',num2str(Wind(i),formatSpec),';\n'] ; fprintf(fid, str);    
end;
for i = 1:Ny
    str = ['l',num2str(i),' =  ',num2str((states(i)*xsil*w)^phil,formatSpec),';\n']; fprintf(fid, str);
end;
str = ['r = ', num2str(R-1,formatSpec),';\n'] ; fprintf(fid, str);
str = ['K = ', num2str(K,formatSpec),';\n'] ; fprintf(fid, str);
str = ['Ltot = ', num2str(Ltot,formatSpec),';\n'] ; fprintf(fid, str);
%str = ['C = ', num2str(Ctot,formatSpec),';\n'] ; fprintf(fid, str);
str = ['w = ', num2str(w,formatSpec),';\n'] ; fprintf(fid, str);
str = ['Z  = 1;\n\n']; fprintf(fid, str);
str = ['u  = 0;\n\n']; fprintf(fid, str);
str = ['GDP = Z*K^alpha*Ltot^(1-alpha);\n']; fprintf(fid, str);

 
str = ['I =  delta*K;\n']; fprintf(fid, str); 
str = ['C =  GDP - G - I;']; fprintf(fid, str); str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;   

str = ['tauk = ', num2str(tk,formatSpec),';\n'] ; fprintf(fid, str);
str = ['taul = ', num2str(tl,formatSpec),';\n'] ; fprintf(fid, str);
str = ['Ctot = ', num2str(Ctot,formatSpec),';\n'] ; fprintf(fid, str);
str = ['TT = ', num2str(TT,formatSpec),';\n'] ; fprintf(fid, str);
str = ['A = ', num2str(A,formatSpec),';\n'] ; fprintf(fid, str);
str = ['B = ', num2str(B,formatSpec),';\n'] ; fprintf(fid, str);


str = ['LGDP = log(GDP);']; fprintf(fid, str); str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;   
str = ['LC   = log(C);']; fprintf(fid, str); str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;   
str = ['LI   = log(I);']; fprintf(fid, str); str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;   
str = ['LL   = log(Ltot);']; fprintf(fid, str); str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;   
str = ['Lw   = log(w);']; fprintf(fid, str); str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;   
str = ['LK   = log(K);']; fprintf(fid, str); str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;   
str = ['LB   = log(B);']; fprintf(fid, str); str = [' %% equation ', num2str(equa),'\n']; fprintf(fid, str); equa = equa+1;   





str = ['FL = (1 - alpha)*Z*(K/Ltot)^alpha;'] ; fprintf(fid, str); 
str = ['FK = alpha*Z*(K/Ltot)^(alpha-1)-delta;'] ; fprintf(fid, str); 

str = ['end;\n\n'] ; fprintf(fid, str);     

str = ['resid;\n\n'] ; fprintf(fid, str); 


str = ['steady(nocheck);\n\n'] ; fprintf(fid, str); 
%str = ['check;\n\n'] ; fprintf(fid, str); 

str = ['shocks;\n var eps; stderr ',num2str(sigma_u,formatSpec),';\n end;\n'] ; fprintf(fid, str);         
%str = ['stoch_simul (order=1,irf=100, hp_filter =1600)  u Z LGDP LI LC LL Lw K L f U;'] ; fprintf(fid, str);         

%str = ['stoch_simul (order=1,irf=100, hp_filter =1600)  u Z GDP C w L I f U;'] ; fprintf(fid, str);   
%str = ['stoch_simul (order=1,irf=100, hp_filter =1600)  u Z GDP C w L I f U;'] ; fprintf(fid, str);   

str = ['stoch_simul (order=1,irf=200, periods = 10000)  u Z GDP C K Ltot B taul;'] ; fprintf(fid, str);       
 dynare dynare_reiter
 save tocompReiter oo_
    